// DeHex.cpp : Defines the entry point for the console application.
// Mark Spankus 2005
//
#include "StdAfx.h"
#include "DeHex.h"


int _tmain(int argc, TCHAR* argv[])
{
	
	FILE* inpfile = stdin;
	FILE* outfile = NULL;
	TCHAR szFile[1024] = {0};
	int nPos = 0;
	bool bOverwrite = false;

	if (argc == 2 )
	{	
		if (!_tcsicmp(argv[1], _T("/?")) || !_tcsicmp(argv[1], _T("-h")) )
		{
usage:
			fputs( "Usage: dehex [-o] [infile] [outfile]\r\n  or   dehex < infile > outfile\r\nConverts a file of hex pairs into binary, ignores ;comment lines\r\nIf [outfile] is missing, default filename of inputfile.bin is used.\r\n-o forces output overwrite\r\nv1.5\r\n", stdout);
			return 0;
		}
	}
	if (argc > 1)
	{
	    int i = 1;


		_tcsncpy(szFile , argv[i], 1023);
		if (!_tcsicmp(argv[i], _T("-o")) )
		{
			i++;
			bOverwrite = true;
			
			if (i >= argc)
				goto usage;
			_tcsncpy(szFile , argv[i], 1023);
		}
		if ( (inpfile = _tfopen(argv[i], _T("rb"))) == NULL)
		{
			_ftprintf(stderr, _T("dehex: Can't open '%s' for input.\n"), argv[i]);
			return -1;
		}

		if ( ++i < argc && (outfile = _tfopen(argv[i], _T("wb"))) == NULL)
		{
			fclose(inpfile);
			_ftprintf(stderr, _T("dehex: Can't open '%s' for output.\n"), argv[i]);
			return -1;
		}

		if (*szFile && outfile == NULL)
		{
			//make an output file base on input now that we know what file
			//we are making
			int nLen = _tcslen(szFile);
			int j = nLen-1;
			while (	j > 0 && szFile[j] != _T('.'))
				j--;
			if (szFile[j] == _T('.'))
				szFile[j] = 0;	
			_tcscat(szFile, _T(".bin"));

			if ( (outfile = _tfopen(szFile, _T("r+b"))) != NULL )
			{
				if (!bOverwrite)
				{
					fclose(outfile);
					fclose(inpfile);
					_ftprintf(stderr, _T("dehex: Target file '%s' exists. Use -o to overwrite\n"), szFile);
					return -1;
				}
			}
			else if ((outfile = _tfopen(szFile, _T("wb"))) == NULL )
			{
				fclose(inpfile);
				_ftprintf(stderr, _T("dehex: Can't open '%s' for output.\n"), szFile);
				return -1;
			}

				

		}
		else if (!outfile)
		{
			outfile = stdout;
		}



	}
	if (outfile == stdout) //ensure our binary \n's don't convert to \r\n!!!!!
	{
#ifdef _WIN32
		_setmode(fileno(stdout), _O_BINARY);
#endif
	}


	bool bnewline = true, bnextline = false;

	while ( feof( inpfile ) == 0 )
	{
		unsigned char c1, c2;

		c1 = fgetc(inpfile);
		if ( bnextline || (c1 < '0' || c1 > '9') && (toupper(c1) < 'A' || toupper(c1) > 'F') )
		{
			
			if (c1 == '\r' || c1 == '\n')
			{
				if (bnextline)
					bnextline = false;
				if (!bnewline)
				{
					bnewline = true;
					if (bnextline)
						bnextline = false;
				}
			}

			if (bnewline && c1 == ';')	//ignore comment lines
				bnextline = true;
			continue;
		}
		else
		{
			bnewline = false;
			if (bnextline)
				continue;
		} 
		c2 = fgetc(inpfile);
		if ( (c2 < '0' || c2 > '9') && (toupper(c2) < 'A' || toupper(c2) > 'F') )
		{
			
			c1 = toupper(c1);
			c1 -= '0';
			if (c1 > 9)
				c1 -= 7;
			fputc(c1, outfile );
			nPos++;
			continue;				
		}

		c1 = toupper(c1);
		c1 -= '0';
		if (c1 > 9)
			c1 -= 7;

		c2 = toupper(c2);
		c2 -= '0';
		if (c2 > 9)
			c2 -=7;
		fputc( ( (c1<<4) | c2), outfile );
		nPos++;

	}

	if (outfile != stdout)
		fclose(outfile);
	return 0;
}

